/*
 * Go2ProfileLineErrorMax.c
 * 
 * Gocator system communication library
 * Copyright (C) 2013 by LMI Technologies Inc.
 * 
 * Licensed under The MIT License.
 * Redistributions of files must retain the above copyright notice.
 */

#include <z/Go2Measurements/zGo2ProfileLineErrorMax.h>
#include <z/zGo2ProfileTypes.h>
#include <z/zGo2System.h>
#include <string.h>

/*
 * Go2ProfileLineErrorMax Class 
 */

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_Construct(Go2ProfileLineErrorMax* measurement, Go2UInt32 id, Go2Object system)
{
    Go2ProfileLineErrorMax output = zNIL; 
    Go2Status status = GO2_OK; 

    zCHECK(zCalloc(&output, 1, sizeof(Go2ProfileLineErrorMaxClass))); 

    if (!zSUCCESS(status = Go2ProfileLineErrorMax_Init(output, id, system)))
    {
        zCHECK(Go2Object_Destroy(output)); 
        return status; 
    }
    
    *measurement = output; 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_Init(Go2ProfileLineErrorMax measurement, Go2UInt32 id, Go2Object system)
{
    Go2ProfileLineErrorMaxClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2Measurement_Init(measurement, GO2_TYPE_PROFILE_LINE_ERROR_MAX, id, system)); 

    obj->Release = Go2ProfileLineErrorMax_VRelease; 
    obj->Read = Go2ProfileLineErrorMax_VRead; 
    obj->Write = Go2ProfileLineErrorMax_VWrite; 

    zCHECK(Go2ProfileArea_Construct(&obj->area, system));       

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_VRelease(Go2ProfileLineErrorMax measurement)
{
    Go2ProfileLineErrorMaxClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2Object_Destroy(obj->area)); 

    zCHECK(Go2Measurement_VRelease(measurement));  
        
    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_VRead(Go2ProfileLineErrorMax measurement, zXml xml, zXmlItem item)
{
    Go2ProfileLineErrorMaxClass* obj = zHANDLE_POINTER(measurement); 
    zChar* text = zNULL;
    z32u textCapacity = GO2_MEASUREMENT_SOURCE_TEXT_CAPACITY; 

    zXmlItem areaItem = zNIL; 

    zCHECK(Go2Measurement_VRead(measurement, xml, item)); 

    zCHECK(zCalloc(&text, textCapacity, sizeof(zChar)));
    zCHECK(zXml_ChildText(xml, item, "SourceOptions", text, textCapacity)); 
    zCHECK(Go2OptionList_ParseList(text, obj->sourceOptions));  

    zCHECK(zXml_Child32u(xml, item, "Source", &obj->source)); 
    

    zCHECK(!zIS_NIL(areaItem = zXml_Child(xml, item, "Area"))); 
    zCHECK(Go2ProfileArea_Read(obj->area, xml, areaItem)); 

    zCHECK(zFree(text));

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_VWrite(Go2ProfileLineErrorMax measurement, zXml xml, zXmlItem item)
{
    Go2ProfileLineErrorMaxClass* obj = zHANDLE_POINTER(measurement); 
    zXmlItem areaItem = zNIL; 

    zCHECK(Go2Measurement_VWrite(measurement, xml, item)); 

    zCHECK(zXml_SetChild32u(xml, item, "Source", obj->source)); 

    zCHECK(zXml_AddItem(xml, item, "Area", &areaItem)); 
    zCHECK(Go2ProfileArea_Write(obj->area, xml, areaItem)); 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_SetId(Go2ProfileLineErrorMax measurement, Go2UInt32 id)
{
    return Go2Measurement_SetId(measurement, id);     
}

GO2_EXPORT(Go2UInt32) Go2ProfileLineErrorMax_Id(Go2ProfileLineErrorMax measurement)
{
    return Go2Measurement_Id(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_SetName(Go2ProfileLineErrorMax measurement, const Go2Char* name)
{
    return Go2Measurement_SetName(measurement, name);     
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_Name(Go2ProfileLineErrorMax measurement, Go2Char* name, Go2UInt32 capacity)
{
    return Go2Measurement_Name(measurement, name, capacity);     
}

GO2_EXPORT(Go2UInt32) Go2ProfileLineErrorMax_SourceOptionCount(Go2ProfileLineErrorMax measurement)
{
    return Go2Measurement_SourceOptionCount(measurement);     
}

GO2_EXPORT(Go2ProfileSource) Go2ProfileLineErrorMax_SourceOptionAt(Go2ProfileLineErrorMax measurement, Go2UInt32 index)
{
    return Go2Measurement_SourceOptionAt(measurement, index);     
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_SetSource(Go2ProfileLineErrorMax measurement, Go2ProfileSource source)
{
    return Go2Measurement_SetSource(measurement, source);     
}

GO2_EXPORT(Go2ProfileSource) Go2ProfileLineErrorMax_Source(Go2ProfileLineErrorMax measurement)
{
    return Go2Measurement_Source(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_SetDecisionMin(Go2ProfileLineErrorMax measurement, Go2Double min)
{
    return Go2Measurement_SetDecisionMin(measurement, min);     
}

GO2_EXPORT(Go2Double) Go2ProfileLineErrorMax_DecisionMin(Go2ProfileLineErrorMax measurement)
{
    return Go2Measurement_DecisionMin(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_SetDecisionMax(Go2ProfileLineErrorMax measurement, Go2Double max)
{
    return Go2Measurement_SetDecisionMax(measurement, max);     
}

GO2_EXPORT(Go2Double) Go2ProfileLineErrorMax_DecisionMax(Go2ProfileLineErrorMax measurement)
{
    return Go2Measurement_DecisionMax(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_EnableHold(Go2ProfileLineErrorMax measurement, Go2Bool enable)
{
    return Go2Measurement_EnableHold(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2ProfileLineErrorMax_HoldEnabled(Go2ProfileLineErrorMax measurement)
{
    return Go2Measurement_HoldEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_EnableSmoothing(Go2ProfileLineErrorMax measurement, Go2Bool enable)
{
    return Go2Measurement_EnableSmoothing(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2ProfileLineErrorMax_SmoothingEnabled(Go2ProfileLineErrorMax measurement)
{
    return Go2Measurement_SmoothingEnabled(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileLineErrorMax_SmoothingWindowMin(Go2ProfileLineErrorMax measurement)
{
    return Go2Measurement_SmoothingWindowMin(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileLineErrorMax_SmoothingWindowMax(Go2ProfileLineErrorMax measurement)
{
    return Go2Measurement_SmoothingWindowMax(measurement);  
} 

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_SetSmoothingWindow(Go2ProfileLineErrorMax measurement, Go2UInt32 window)
{
    return Go2Measurement_SetSmoothingWindow(measurement, window);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileLineErrorMax_SmoothingWindow(Go2ProfileLineErrorMax measurement)
{
    return Go2Measurement_SmoothingWindow(measurement);  
} 

GO2_EXPORT(Go2ProfileArea) Go2ProfileLineErrorMax_Area(Go2ProfileLineErrorMax measurement)
{
    Go2ProfileLineErrorMaxClass* obj = zHANDLE_POINTER(measurement); 
    return obj->area;  
}




GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_SetScale(Go2ProfileLineErrorMax measurement, Go2Double scale){
    return Go2Measurement_SetScale(measurement, scale);
}

GO2_EXPORT(Go2Double) Go2ProfileLineErrorMax_Scale(Go2ProfileLineErrorMax measurement){
    return Go2Measurement_Scale(measurement);
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_SetOffset(Go2ProfileLineErrorMax measurement, Go2Double offset){
    return Go2Measurement_SetOffset(measurement, offset);
}

GO2_EXPORT(Go2Double) Go2ProfileLineErrorMax_Offset(Go2ProfileLineErrorMax measurement){
    return Go2Measurement_Offset(measurement);
}

GO2_EXPORT(Go2UInt32) Go2ProfileLineErrorMax_LinkOptionCount(Go2ProfileLineErrorMax measurement)
{
    return Go2Measurement_LinkOptionCount(measurement);
}

GO2_EXPORT(Go2UInt32) Go2ProfileLineErrorMax_LinkOptionAt(Go2ProfileLineErrorMax measurement, Go2UInt32 index)
{
    return Go2Measurement_LinkOptionAt(measurement, index);
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_EnableLink(Go2ProfileLineErrorMax measurement, Go2Bool enable)  
{
    return Go2Measurement_EnableLink(measurement, enable);  
}

GO2_EXPORT(Go2Bool) Go2ProfileLineErrorMax_LinkEnabled(Go2ProfileLineErrorMax measurement)  
{
    return Go2Measurement_LinkEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2ProfileLineErrorMax_SetLink(Go2ProfileLineErrorMax measurement, Go2UInt32 link) 
{
    return Go2Measurement_SetLink(measurement, link); 
}

GO2_EXPORT(Go2UInt32) Go2ProfileLineErrorMax_Link(Go2ProfileLineErrorMax measurement) 
{
    return Go2Measurement_Link(measurement); 
}
